#ifModif.py
from socket import *
import sys
import httplib
from time import * #per benchmarking

class ifModif:
    '''questo modulo si connette ad internet ed esamina se una lista di siti
    archiviata sul file 'arkself.sites.fk'  stata aggiornata'''
 
    def __init__(self, archivio):
        self.str = archivio
        try:
            f = file(self.str,'r')
        except Exception:
            self.nofile = 1
            print 'Errore di i/o: impossibile trovare il file ', self.str
        else:
            self.nofile = 0
            self.righe = f.readlines()
            f.close()
            self.sites = []
            self.pages = []
            self.dates = []
            
            for x in range(len(self.righe)):
                if (x % 4) == 0:
                    if self.righe[x] != '':
                        app = self.righe[x]
                        self.sites.append(app[:len(app)-1]) #taglio \n a fine riga
                elif (x % 4) == 1:
                    if self.righe[x] != '':
                        app = self.righe[x]
                        self.pages.append(app[:len(app)-1])
                elif (x % 4) == 2:
                    if self.righe[x] != '':
                        app = self.righe[x]
                        self.dates.append(app[:len(app)-1])
            print 'Istanza di ifModif creata con successo'

    def __aggiornaFile(self):
        '''aggiorna il file di archivio'''
        o = file(self.str,'w')
        for x in range(len(self.sites)):
            o.writelines(self.sites[x]+'\n')
            o.writelines(self.pages[x]+'\n')
            o.writelines(self.dates[x]+'\n')
            o.writelines('\n')
        o.close()

    def control(self):
        '''si connette al web e controlla se le pagine sono aggiornate'''
        if self.nofile:
            print 'Archivio assente: impossibile continuare'
        else:
            print 'Sto eseguendo Aggioramento..'
            devoaggiornare = 0
            for x in range(len(self.sites)):
                try:
                    conn = httplib.HTTPConnection(self.sites[x])
                    conn.request('HEAD',self.pages[x])
                    resp = conn.getresponse()
                    conn.close()
                except Exception:
                    print 'Errore sul sito',self.sites[x],': impossibile connettersi'
                    devoaggiornare = False
                else:
                    if resp.status != 200:
                        print 'Errore sul sito',self.sites[x],': ', resp.status, resp.reason
                        conn.close()
                    else:
                        data = resp.getheader('Last-Modified')
                        conn.close()
                        if (data != None) and (data != self.dates[x]):
                            self.dates[x] = data
                            print 'Sito', self.sites[x], ': aggiornato'
                            print '    ',data
                            devoaggiornare = 1
                        else:
                            print 'Sito',self.sites[x], ': non aggiornato'
            if devoaggiornare:
                self.__aggiornaFile()
                print "Aggioramento dell'archivio terminato con successo!"


if __name__=='__main__':
    time1 = clock()
    x = ifModif('ifModif.txt')
    x.control()
    time2 = clock()
    print 'Ci ho messo %f secondi' % (time2-time1)
#:-
